import cv2
import numpy as np
from PIL import Image
import os
# Ścieżka do katalogu z danymi
path = 'dataset'
recognizer = cv2.face.LBPHFaceRecognizer_create()
# recognizer = cv2.face.createLBPHFaceRecognizer()
detector = cv2.CascadeClassifier("Cascades/haarcascade_frontalface_default.xml");
# Nasza funkcja do pobierania zdjęć i ich oznaczania
def getImagesAndLabels(path):
    imagePaths = [os.path.join(path,f) for f in os.listdir(path)]     
    faceSamples=[]
    ids = []
    for imagePath in imagePaths:
        PIL_img = Image.open(imagePath).convert('L') # zamaiana na szarość
        img_numpy = np.array(PIL_img,'uint8')
        id = int(os.path.split(imagePath)[-1].split(".")[1])
        faces = detector.detectMultiScale(img_numpy)
        for (x,y,w,h) in faces:
            faceSamples.append(img_numpy[y:y+h,x:x+w])
            ids.append(id)
    return faceSamples,ids
print ("\n [INFO] Uczymy rozpoznawać dodane osoby. Zajmie to kilka sekund. Zaczekaj ...")
faces,ids = getImagesAndLabels(path)
recognizer.train(faces, np.array(ids))
# Zapisujemy nasz plik tutaj -> trainer/trainer.yml
#recognizer.write('trainer/trainer.yml') # recognizer.save() worked on Mac, but not on Pi
recognizer.save('trainer/trainer.yml')
# Wyświetlamy liczbę nauczonych twarzy 
print("\n [INFO] {0} nauczonych osob".format(len(np.unique(ids)))) 